import java.util.Vector;

public class Boxing3{

	public static void main(String[] args){
		// Typisierter Vector s. Generics?.java
		Vector<Double> v = new Vector<Double>(10);
		double d1 = 1.5;
		double d2 = 2.5;
		
		// Das geht ab Java5 automatisch, da primitive Typen
		// bei Bedarf in ihre Wrapper-Klassen eingepackt werden (AutoBoxing).
		// AutoBoxing
		v.add(d1);
		// AutoBoxing
		v.add(d2);


		// Alle Elemente des Vectors ausgeben
		for(int i=0; i<v.size(); ++i){
			// Zuweisung geht ab Java5 ebenfalls, da der primitive Typ
			// bei Bedarf automatisch ausgepackt wird (AutoUnboxing).
			// AutoUnboxing
			double value = v.elementAt(i);
			System.out.println("Wert: "+value);
		}
		// Aufruf der Methode add
		// -> Schon beim Aufruf AutoBoxing!
		System.out.println("Summe: "+add(d1,d2));
		// Entspricht:
		// System.out.println("Summe: "+add(new Double(d1), new Double(d2))); 
		
	}

	// Achtung Performance!
	// Diese Methode ist sehr unguenstig, da Double ein unveraenderbarer
	// Typ ist und somit viel AutoBoxing und AutoUnboxing verwendet wird!
	public static Double add(Double d1, Double d2){
		return d1+d2;
		// Entspricht:
		// double tmp1 = d1.doubleValue(); // Unboxing
		// double tmp2 = d2.doubleValue(); // Unboxing
		// double d = tmp1+tmp2;
		// return new Double(d); // Boxing
	}
}
